#!/usr/bin/perl
#-------------------------------------------------------------------
# This file is part of the wwwoffle-sql package
#
#  Version : 0.02  Released : 03/05/99
#
# Author : Peter Marbaise (pema@hippo.fido.de,2:2452/110.20)
#
#              GNU GENERAL PUBLIC LICENSE Version 2
#              (see LICENSE for the complete text)
#
#-------------------------------------------------------------------

package wwwofflelib;
require Exporter;
@ISA  = qw(Exporter);
@EXPORT = qw(insertdb initdb htmlfooter htmlheader findversion);
@EXPORT_OK = qw($dbh $drh);
use DBI;

#($dbh,$drh)=initdb();

sub initdb {
#load the driver for mysql
    $drh=DBI->install_driver('mysql');
    die "Could not load mysql driver\n" unless $drh;
    
    $dbh=$drh->connect("wwwoffle","root","annopro");
    die "Failed to connect to mysql server\n" unless $dbh;
    return ($dbh,$drh);
}
# host 0 page 1 length 2 keywords 3 date 4 server 5 version 6 usrkeyw 7
sub insertdb {


    ($SID) = SearchHost ( $_[0] );
    # insert or update server first
    if ( $SID eq "" ) {
        ($SID) = SearchWWWServer ( $_[5] );
        $sel_line="INSERT into hosts ";
        $sel_line=$sel_line."( name ,sID ) ";
        $sel_line=$sel_line." values ( '$_[0]' , '$SID' )";
        $csr=$dbh->prepare("$sel_line") || die "cant prepare statement";
        $csr->execute or die "cant execute insert statement";
        $csr->finish;
    }
    
    #find out serverid
    ($SID) = SearchHost ( $_[0] );
    # insert references
    ($REF) = SearchRef ( $SID , $_[1] );
    if ( $REF ne "" ) {
            $sel_line = "UPDATE hostpages SET keywords='$_[3]',size='$_[2]',";
            $sel_line = $sel_line." version='$_[6]'";
            if ( $_[7] ne "" ) {
                $sel_line = $sel_line.=",usrkeywords='$_[7]'";
            }
            $sel_line = $sel_line." WHERE ID='$SID' AND ref='$REF'";
            $csr=$dbh->prepare("$sel_line") || die "cant prepare statement";
            $csr->execute or die "cant execute update statement";
            $csr->finish;
    }
    else {
            $sel_line="INSERT into hostpages ";
            $sel_line=$sel_line."( ref , ID , keywords ,usrkeywords, Datum , size ,version ) ";
            $sel_line=$sel_line." values ( '$_[1]' , '$SID', '$_[3]','$_[7]', '$_[4]','$_[2]','$_[6]' )";
            $csr=$dbh->prepare("$sel_line") || die "cant prepare statement";
            $csr->execute or die "cant execute insert statement";
            $csr->finish;
            $sel_line="";
    }        
    return 0;
    
}

sub htmlfooter {
    print "<HR>";
    print "page generated with wwwoffle-sql scripts &copy 1998  ";
    print "<A HREF=\"mailto:pema\@hippo.fido.de?subject=wwwoffle-sql\">Peter Marbaise</A><br>";
    print "Release : 0.02 03/05/99&nbsp;&nbsp;&nbsp;&nbsp;";
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    print "<A HREF=wwwofflesql.html>WWWoffle-SQL main page</A>";
    print "</body></html>";
}

# $_[0] Ttile of page $_[1] heading
sub htmlheader {
    print "<html>";
    print "<head>";
    print "<meta http-equiv=\"expires\" content=\"0\">";
    print "<TITLE>$_[0]</TITLE>";
    print "<link rel=stylesheet type=\"text/css\" href=\"formate.css\"> ";
    print "</head>";
    print "<body>";
    print "<BODY TEXT=\"#000000\" BGCOLOR=\"#FFFFEF\">";
    print "<IMG SRC=\"wwwoffle-still.gif\" BORDER=0 align=right>";
    print "<h1>$_[1]</h1>";
    print "<HR>";
}

sub findversion {
  my $lversion = "";
  if ( $_[0] =~ /(([0-9]+\.[0-9\.]+)|([0-9]+\.[0-9]+))(\.gz|\.tgz|\.tar\.gz|\.zip|\.exe|\.tar\.bz|\.tar\.bz2)$/ ) {
       $lversion = $1
  }

  return ($lversion);
}
##############################################################
sub input {
	local($line);
	print $_[0];
	$line=<STDIN>;
	chop($line);
	$line;
}

sub SearchHost {
  my $ID = 0;  
  $sel_line = "SELECT ID from hosts where name='$_[0]'";
  $csr=$dbh->prepare("$sel_line") || die "cant prepare statement";
  $csr->execute or die "cant execute insert statement";
  ($ID)=$csr->fetchrow;
  return ($ID);
}
sub SearchRef {
    my $found = 0;
    $sel_line = "SELECT ref from hostpages where ";
    $sel_line = $sel_line." ID='$_[0]' AND ref='$_[1]'";
    $csr=$dbh->prepare("$sel_line") || die "cant prepare statement";
    $csr->execute or die "cant execute SELECT statement";
    ($found)=$csr->fetchrow;
    return ($found);
}
sub SearchWWWServer {

    my $found = 0;

    $sel_line = "SELECT ID from server where name='$_[0]'";
    $csr=$dbh->prepare("$sel_line") || die "cant prepare statement";
    $csr->execute or die "cant execute SELECT statement";
    ($found)=$csr->fetchrow;

    if ( $found ne "" )  {
        return ($found);
    } else
    {
        $sel_line = "INSERT into server ( name ) values ('$_[0]')";    
        $csr=$dbh->prepare("$sel_line") || die "cant prepare statement";
        $csr->execute or die "cant execute INSERT statement";
        $csr->finish;
        $sel_line = "SELECT ID from server where name='$_[0]'";
        $csr=$dbh->prepare("$sel_line") || die "cant prepare statement";
        $csr->execute or die "cant execute SELECT statement";
        ($found)=$csr->fetchrow;
        return ($found);
    }
}
                     
# end of WWWOFFLELIB 
